/* 

   This code was ported to the Sega Dreamcast ( all rights reserved )
   using KOS ( http://dcdev.allusion.net/ ) and its addon library KGL.
   
   It was ported by Stephen Bolton ( aka HyperG - hyper_gamer13@hotmail.com ).
   
   I also would like to thank Flecko for helping me get started with OpenGL.
   
   Code was first rewritten by Flecko, but the triangle was fixed by HyperG,
   and controller code was added by HyperG also.
   
*/

/*              
 *              This Code Was originally Created By Jeff Molofee 2000
 *		A HUGE Thanks To Fredric Echols For Cleaning Up
 *		And Optimizing The Base Code, Making It More Flexible!
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit My Site At nehe.gamedev.net
 */
#include <kos.h>
#include <GL\gl.h>			// Header File For The OpenGL32 Library
#include <GL\glu.h>			// Header File For The GLu32 Library

/* Everything commented was the code that wasn't needed for this Dreamcast port */

GLvoid ReSizeGLScene()									// Resize And Initialize The GL Window
{
	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glLoadIdentity();								// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,640.0f/480.0f,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

void DrawGLScene()									// Here's Where We Do All The Drawing
{
	glLoadIdentity();							// Reset The Current Modelview Matrix
	glTranslatef(-1.5f,0.0f,-6.0f);						// Move Left 1.5 Units And Into The Screen 6.0
        glColor3f(1.0f, 1.0f, 1.0f); //you have to add this, or else you won't see the triangle. Dreamcast doesn't gray it like the PC does.
        glBegin(GL_TRIANGLES);	
                glVertex3f( 0.0f, 1.0f, 0.0f);				// Top
                glVertex3f( 1.0f,-1.0f, 0.0f);				// Bottom Left
                glVertex3f(-1.0f,-1.0f, 0.0f);				// Bottom Right
	glEnd();							// Finished Drawing The Triangle
	glTranslatef(3.0f,0.0f,0.0f);	
	glColor3f(1.0f, 1.0f, 1.0f); //you have to add this, or else you won't see the square.						// Move Right 3 Units
	glBegin(GL_QUADS);					        // Draw A Quad
		glVertex3f(-1.0f, 1.0f, 0.0f);				// Top Left
		glVertex3f( 1.0f, 1.0f, 0.0f);				// Top Right
		glVertex3f( 1.0f,-1.0f, 0.0f);				// Bottom Right
		glVertex3f(-1.0f,-1.0f, 0.0f);				// Bottom Left
	glEnd();							// Finished drawing the quad
}

int main(int argc, char **argv)	
{
	uint8 c;
	cont_cond_t cond;
	
	kos_init_all(THD_ENABLE | IRQ_ENABLE | TA_ENABLE, ROMDISK_NONE);	// set up KOS
	glKosInit();
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black									// Init KGL
	glShadeModel(GL_SMOOTH);			// Enable Smooth Shading
	c = maple_first_controller();                   // Global for First Controller

	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	while(1) 
								// Infinite loop, the best kind			
	{
		/* Check key status */
		if (cont_get_cond(c, &cond) < 0)
			break;
		if (!(cond.buttons & CONT_START))
			break;

		glKosBeginFrame();					// Tell KOS to start the frame
		ReSizeGLScene();  					// This isn't really a needed function...but you get the idea
		DrawGLScene();						// Draw the scene
		glKosFinishFrame();					// Tell KOS you're done with the frame
	}
	return 0;
}
